package test.framework;

import java.util.Enumeration;
import java.util.Vector;

public class TestSuite implements Test {
   private Vector fTests = new Vector(10);

   public void run(TestResult result) {
      Enumeration e = this.fTests.elements();

      while(e.hasMoreElements() && !result.shouldStop()) {
         Test test = (Test)e.nextElement();
         test.run(result);
      }

   }

   public void addTest(Test test) {
      this.fTests.addElement(test);
   }

   public int countTestCases() {
      int count = 0;

      Test test;
      for(Enumeration e = this.fTests.elements(); e.hasMoreElements(); count += test.countTestCases()) {
         test = (Test)e.nextElement();
      }

      return count;
   }

   public String toString() {
      return this.fTests.toString();
   }
}
